/*
 *
 *  Created on: Mar 1, 2021
 *      Author: astrisw
 */

#pragma once

#include <Base_Provider.h>
#include <unordered_map>
#include <librdkafka/rdkafkacpp.h>
#include <atomic>
#include <thread>
#include <Delivery_Report.h>


namespace inaf::oasbo::Providers {
class KafkaProvider : public BaseProvider{
protected:
	std::string brokerIp;
	int brokerPort;
	RdKafka::Producer *producer = nullptr;
	std::atomic<bool> stopFlag = false;
	std::thread pollThread;
	DeliveryReportCb *dr_cb = nullptr;

	std::string getBrokerIp(){return this->brokerIp;}
	int getBrokerPort(){return this->brokerPort;}
	void setBrokerIp(std::string ip){this->brokerIp=ip;}
	void setBrokerPort(int port){this->brokerPort=port;}

	void pollingThreadFunction();


public:
	KafkaProvider();
	KafkaProvider(std::string ip, int port, std::string topic);

	void setDest(std::string dest){this->dest = dest;}
	std::string getDest(){return dest;}

	int write(PacketLib::BasePacket &);
	int write(PacketLib::BasePacket &, std::string dest);

	int close();
	int open();
	bool isOpen();
	~KafkaProvider();

};
}
